/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.c
* Author             : WCH
* Version            : V1.2
* Date               : 2020/05/27
* Description 		 : ϵͳ˯ģʽʾGPIOA_6GPIOA_5ΪԴ6˯ߵȼ
*******************************************************************************/

/* 
ע⣺ʹõ͹ģIdleģʽ⣩˯߻ѺҪϵͳʱӣʹõڲ32Mʱ5Ƶ6.4MƵ 
лⲿHSEֱƵ߼ӷʽPLLͨPLLƵƵѺʱ1.2msһ㣩лHSEȶ
лڲHSIֱƵ߼ӷʽPLLͨPLLƵƵѺȴʱ䡣

ע⣺лHSEʱԴȴȶʱѡþйأѡһµľĶṩľ弰
صݲֵͨR8_XT32M_TUNEĴòͬĸصݺƫõȶʱ䡣
*/

#include "CH57x_common.h"

void DebugInit(void)		
{
    GPIOA_SetBits(GPIO_Pin_9);
    GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
}

int main()
{
    DelayMs(2); 
    SetSysClock( CLK_SOURCE_HSE_32MHz );            // ⲿ32MƵ
    GPIOA_ModeCfg( GPIO_Pin_All, GPIO_ModeIN_PU );
    GPIOB_ModeCfg( GPIO_Pin_All, GPIO_ModeIN_PU );
    
    DelayMs(3000); 
    /* ôڵ */   
    DebugInit();
    PRINT( "Start @ChipID=%02x\n", R8_CHIP_ID );
    DelayMs(200); 
	/*ӡϵĸλ״̬Ϣ*/
		PRINT( "reset:%x.\n",R8_RESET_STATUS);	
	if((R8_RESET_STATUS & RB_RESET_FLAG) == RST_FLAG_RPOR){//ϵ縴λ
		 PRINT( "power up ++++++.\n");
	}else if((R8_RESET_STATUS & RB_RESET_FLAG) == RST_FLAG_SW){//λ
		 PRINT( "software reset ++++++.\n");
	}else{
		PRINT( "reset:%x.\n",R8_RESET_STATUS);
	}
#if 1	
	/*ʼRTCʱ*/
	R8_SAFE_ACCESS_SIG = 0x57; 
	R8_SAFE_ACCESS_SIG = 0xa8;
	R8_CK32K_CONFIG    |=  RB_CLK_INT32K_PON | RB_CLK_XT32K_PON;
	R8_CK32K_CONFIG &= ~RB_CLK_OSC32K_XT;
	R8_RTC_MODE_CTRL   |= RB_RTC_TMR_EN|0x07;//ʹж
	R8_SAFE_ACCESS_SIG = 0;
	RTC_InitTime( 2021, 8, 5, 10, 0, 0 );    //RTCʱӳʼǰʱ
	//NVIC_EnableIRQ( RTC_IRQn );		/* ʹж */
#endif
#if 1    
    /* ûԴΪ GPIO - PA6&PA5 */
    GPIOA_ModeCfg( GPIO_Pin_6|GPIO_Pin_5, GPIO_ModeIN_PD );

	
//	while((GPIOA_ReadPortPin(GPIO_Pin_5) == 0) && (GPIOA_ReadPortPin(GPIO_Pin_6)==0)){
//		    PRINT( "PA5 PA6 \n");
//	}
	DelayMs(3000); 
	GPIOA_ITModeCfg( GPIO_Pin_6|GPIO_Pin_5, GPIO_ITMode_RiseEdge );        // ػ
    //NVIC_EnableIRQ( GPIO_IRQn );
    PWR_PeriphWakeUpCfg( ENABLE, RB_SLP_GPIO_WAKE );
	
//	R8_SAFE_ACCESS_SIG = 0x57; 
//	R8_SAFE_ACCESS_SIG = 0xa8;
//	R8_XT32K_TUNE &= ~RB_XT32K_I_TUNE;//70%
//	R8_SAFE_ACCESS_SIG = 0;
	
#endif    
    
//#if 1
//    PRINT( "IDLE mode sleep \n");   
//    DelayMs(1);
//    LowPower_Idle();
//    PRINT( "wake.. \n"); 
//    DelayMs(500);
//#endif    
//    
//#if 1
//    PRINT( "Halt_1 mode sleep \n");   
//    DelayMs(1);
//    LowPower_Halt_1();
///*
//ʹHSI/5=6.4M˯ߣʱҪ 2048Tsys330us
//HSEһ㲻1.2ms(500us-1200us)лⲿHSEҪ 1.2ms-330us ʱԱ֤HSE㹻ȶһ
//DelayUs()ʱ32MʱӵдʱƵΪ6.4M DelayUs((1200-330)/5)    
//*/
//    if(!(R8_HFCK_PWR_CTRL&RB_CLK_XT32M_PON)) {     // ǷHSEϵ
//        PWR_UnitModCfg( ENABLE, UNIT_SYS_HSE );   // HSEϵ
//        DelayUs((1200)/5);
//    }
//    else if(!(R16_CLK_SYS_CFG&RB_CLK_OSC32M_XT)){   // Ƿѡ HSI/5 ʱԴ
//        DelayUs((1200-330)/5);
//    } 
//    HSECFG_Current( HSE_RCur_100 );     // Ϊ(͹ĺHSEƫõ)
//    DelayUs(5/5);                       // ȴȶ 1-5us
//    SetSysClock( CLK_SOURCE_HSE_32MHz );
//    PRINT( "wake.. \n"); 
//    DelayMs(500);    
//#endif    
//    
//#if 1
//    PRINT( "Halt_2 mode sleep \n");   
//    DelayMs(1);
//    LowPower_Halt_2();
///*
//ʹHSI/5=6.4M˯ߣʱҪ 2048Tsys330us
//HSEһ㲻1.2ms(500us-1200us)лⲿHSEҪ 1.2ms-330us ʱԱ֤HSE㹻ȶһ
//DelayUs()ʱ32MʱӵдʱƵΪ6.4M DelayUs((1200-330)/5)    
//*/
//    if(!(R8_HFCK_PWR_CTRL&RB_CLK_XT32M_PON)) {     // ǷHSEϵ
//        PWR_UnitModCfg( ENABLE, UNIT_SYS_HSE );   // HSEϵ
//        DelayUs((1200)/5);
//    }
//    else if(!(R16_CLK_SYS_CFG&RB_CLK_OSC32M_XT)){   // Ƿѡ HSI/5 ʱԴ
//        DelayUs((1200-330)/5);
//    } 
//    HSECFG_Current( HSE_RCur_100 );     // Ϊ(͹ĺHSEƫõ)
//    DelayUs(5/5);                       // ȴȶ 1-5us
//    SetSysClock( CLK_SOURCE_HSE_32MHz );
//    PRINT( "wake.. \n"); 
//    DelayMs(500);    
//#endif    

//#if 1
//    PRINT( "sleep mode sleep \n");   
//    DelayMs(1);
//    LowPower_Sleep( RB_PWR_RAM14K|RB_PWR_RAM2K );       //ֻ14+2K SRAM 
///*
//ʹHSI/5=6.4M˯ߣʱҪ 2048Tsys330us
//HSEһ㲻1.2ms(500us-1200us)лⲿHSEҪ 1.2ms-330us ʱԱ֤HSE㹻ȶһ
//DelayUs()ʱ32MʱӵдʱƵΪ6.4M DelayUs((1200-330)/5)    
//*/
//    if(!(R8_HFCK_PWR_CTRL&RB_CLK_XT32M_PON)) {     // ǷHSEϵ
//        PWR_UnitModCfg( ENABLE, UNIT_SYS_HSE );   // HSEϵ
//        DelayUs((1200)/5);
//    }
//    else if(!(R16_CLK_SYS_CFG&RB_CLK_OSC32M_XT)){   // Ƿѡ HSI/5 ʱԴ
//        DelayUs((1200-330)/5);
//    } 
//    HSECFG_Current( HSE_RCur_100 );     // Ϊ(͹ĺHSEƫõ)
//    DelayUs(5/5);                       // ȴȶ 1-5us
//    SetSysClock( CLK_SOURCE_HSE_32MHz );
//    PRINT( "wake.. \n");      
//    DelayMs(500);
//#endif

#if 1
    PRINT( "shut down mode sleep \n");   
    DelayMs(1);
    LowPower_Shutdown( RB_PWR_RAM2K );                          //ȫϵ磬Ѻλ
/* 
   ģʽѺִиλ벻У
   עҪȷϵͳ˯ȥٻѲǻѸλпܱIDLEȼ 
*/
/*
ʹHSI/5=6.4M˯ߣʱҪ 2048Tsys330us
HSEһ㲻1.2ms(500us-1200us)лⲿHSEҪ 1.2ms-330us ʱԱ֤HSE㹻ȶһ
DelayUs()ʱ32MʱӵдʱƵΪ6.4M DelayUs((1200-330)/5)    
*/
    if(!(R8_HFCK_PWR_CTRL&RB_CLK_XT32M_PON)) {     // ǷHSEϵ
        PWR_UnitModCfg( ENABLE, UNIT_SYS_HSE );   // HSEϵ
        DelayUs((1200)/5);
    }
    else if(!(R16_CLK_SYS_CFG&RB_CLK_OSC32M_XT)){   // Ƿѡ HSI/5 ʱԴ
        DelayUs((1200-330)/5);
    } 
    HSECFG_Current( HSE_RCur_100 );     // Ϊ(͹ĺHSEƫõ)
    DelayUs(5/5);                       // ȴȶ 1-5us
    SetSysClock( CLK_SOURCE_HSE_32MHz );
    PRINT( "wake.. \n");
    DelayMs(500);
#endif

    while(1);    
}


void GPIO_IRQHandler(void)
{
    GPIOA_ClearITFlagBit( GPIO_Pin_6|GPIO_Pin_5 );
}




